% Clase regval
% Definiciones comunes para imprimir registros valorativos.
% Dominio pblico. 2003. Sin garantas. http://structio.sourceforge.net/sigue
% Basado en clase empleada en el Gimnasio Fidel Cano http://www.gfc.edu.co

\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{regval}

\ProcessOptions

\LoadClass{report}
\PassOptionsToClass{legalpaper}{report}

\usepackage[T1]{fontenc}
\usepackage{longtable}
\usepackage{ifthen}
\usepackage[legalpaper]{geometry}
\geometry{verbose,tmargin=5mm,bmargin=65mm,lmargin=8mm,rmargin=25mm,headheight=25mm,headsep=5mm,footskip=5mm}
\usepackage{fancyhdr}
\pagestyle{fancy}
\usepackage[spanish]{babel}
\setlength\parskip{\medskipamount}
\setlength\parindent{0pt}

% El siguiente macro es adaptado de \edefappend de eplain http://www.ccs.neu.edu/home/dorai/eplain/
\def\xdefappend#1#2{
  \toks@ = \expandafter{#1}
  \xdef#1{\the\toks@ #2}
}

\ifx\@observaciones\@undefined
\xdef\@observaciones{}
\fi
\def\estudiante#1{\gdef\@estudiante{#1}}
\def\grado#1{\gdef\@grado{#1}}
\def\periodo#1{\gdef\@periodo{#1}}
\def\fecha#1{\gdef\@fecha{#1}}
\def\moderador#1{\gdef\@moderador{#1}}
\def\observacion#1{
\def\a{#1}
\def\b{|Observaciones|}
\ifx\a\b \else \xdefappend\@observaciones{#1} \fi
}

\setlength{\columnsep}{1.5pc}
\setlength{\voffset}{3cm}
\chead{{\large{NUESTRA ESCUELA}\\
Aprendiendo con amor, respeto, humildad y sin excusas}\\
Registro Valorativo Individual \\
Estudiante : \@estudiante\\
\hfill Grado : \@grado \hfill Perodo : \@periodo \hfill Fecha  :
\@fecha \hfill Pgina \thepage \hfill\\
}
\cfoot{}
\renewcommand{\headrulewidth}{0pt}

\newenvironment{valoraciones}{
\begin{longtable}{p{17cm}c}
%\textbf{\hspace{5cm} Indicador} &\textbf{Valoracin} \\
&\textbf{Valoracin} \\
%\hline
\endhead
\multicolumn{2}{r}{Contina}
\endfoot
\endlastfoot
}
{
\end{longtable}
}

% asignatura y evaluable deben ser definidos por una clase que incluya a esta

\newcommand{\area}[2]{
\\
\hline
\textbf{#1} & \textbf{#2} 
%\multicolumn{2}{c}{\textbf{#1}} \\
}

\newcommand{\valoracion}[2]{
#1& \textbf{#2} \\
}

\newcommand{\pie}{
\parbox{15cm}{\textbf{Observaciones}:\\
\\
\@observaciones
%\hfill\rule{18cm}{.05pc} \\
%\\
%\hfill\rule{18cm}{.05pc} \\
%\\
}
%\nopagebreak
%\vspace{3cm}
%\nopagebreak

\begin{center}
\begin{tabular}{cc}
\rule{7cm}{.05pc} & \rule{7cm}{.05pc} \\
Coordinador(a) de Grupo & Rector(a) \\
\@moderador & NN
\end{tabular}
\end{center}


\vspace{2cm}

}

\endinput



