<?xml version="1.0" encoding="ISO-8859-1"?>
<!-- A partir de un archivo .planest para repasa genera un script
     que cuenta valoraciones.
  Se cede esta fuente al dominio pblico 2006.  Sin garantas.
  http://structio.sourceforge.net/sigue structio-info@lists.sourceforge.net 
-->
<!DOCTYPE xsl:stylesheet [
]>

<xsl:stylesheet version="1.0"
        xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="html" encoding="ISO-8859-1"/>

<xsl:param name="periodo" required="yes"/>
<xsl:param name="dircla" required="yes"/>
<xsl:param name="dirplanest" required="yes"/>
<xsl:param name="logros" required="yes"/>
<xsl:param name="indicadores" required="yes"/>

<xsl:template match="planest">
	<html><head><title>Estadsticas periodo <xsl:value-of select="$periodo"/> </title></head><body>
		<xsl:apply-templates/>
	</body></html>
</xsl:template>

<xsl:template match="curso">
  <xsl:param  name="refgrupo"/>
     <hr/><h2><xsl:value-of select="./desc"/>
	  <xsl:if test="./@refmoderador!=''">
		   (<xsl:value-of select="document(./@refmoderador)/individuo/dato[@tipo='Nombres']"/> <xsl:text> </xsl:text><xsl:value-of select="document(./@refmoderador)/individuo/dato[@tipo='Apellidos']"/>) 
	   </xsl:if> 
  </h2> 
  <!-- <xsl:if test="./@id='kinder' or ./@id='preescolar'" > -->
  <xsl:apply-templates>
	<xsl:with-param  name="refgrupo" select="./@refgrupo"/>
	<xsl:with-param  name="nomgrado" select="./desc"/>
</xsl:apply-templates>  
<!-- </xsl:if> -->
</xsl:template>


<xsl:template match="asignatura">
  <xsl:param  name="refgrupo"/>
  <xsl:param  name="nomgrado"/>
  <xsl:choose>
    <xsl:when test="./@refsectemas!='' and ./@refmoderador!=''">
      <xsl:variable name="nomsinext">
      	<xsl:value-of select='substring-before(./@refsectemas,".sec")'/>
      </xsl:variable>
      <xsl:variable name="nomasig">
	      <xsl:value-of select="./desc"/>
      </xsl:variable>
           <h3><xsl:value-of select="./desc"/> 
	      (<xsl:value-of select="document(./@refmoderador)/individuo/dato[@tipo='Nombres']"/> <xsl:text> </xsl:text><xsl:value-of select="document(./@refmoderador)/individuo/dato[@tipo='Apellidos']"/>)
      </h3> 
      <table border='1'>
	<tr><th><xsl:value-of select="$indicadores"/></th><th>E</th><th>S</th><th>A</th><th>I</th><th>D</th></tr> 
	<!-- <xsl:if test="./@prc='comunicativa.prc'">  -->
	  <xsl:apply-templates select="document(./@refsectemas)/secuencia/sec[@id=$periodo]/refcla">
	<xsl:with-param  name="prc" select="./@prc"/>
	<xsl:with-param  name="nomsinext" select="$nomsinext"/>
	<xsl:with-param  name="refgrupo" select="$refgrupo"/>
       </xsl:apply-templates>  

       <!-- </xsl:if>  -->

	       </table>
     
    </xsl:when>
    <xsl:otherwise>
    </xsl:otherwise>
  </xsl:choose>
  <xsl:apply-templates>
	<xsl:with-param  name="refgrupo" select="$refgrupo"/>
	<xsl:with-param  name="nomgrado" select="$nomgrado"/>
  </xsl:apply-templates> 
</xsl:template>

<xsl:template match="desc">
</xsl:template>


<xsl:template match="refcla">
  <xsl:param  name="prc"/>
  <xsl:param  name="nomsinext"/>
  <xsl:param  name="refgrupo"/>
  <xsl:value-of select="$dircla"/>
      <xsl:variable name="idcla">
	      <xsl:value-of select='concat($dircla, $nomsinext,".cla:",./@idcla)'/>
      </xsl:variable>
      <xsl:text>
      </xsl:text>
      <tr>
      <td><xsl:value-of select="./@idcla"/> </td>
      <xsl:variable name="nume">
	<xsl:apply-templates select="document($refgrupo)/grupo/refind">
	  <xsl:with-param  name="prc" select="$prc"/>
	  <xsl:with-param  name="idcla" select="$idcla"/>
	  <xsl:with-param  name="valmin" select="'9.0'"/>
	  <xsl:with-param  name="valmax" select="'10.1'"/>
	</xsl:apply-templates>   
	</xsl:variable>
	<td> <xsl:value-of select="string-length($nume)"/> </td>
      <xsl:variable name="nums">
	<xsl:apply-templates select="document($refgrupo)/grupo/refind">
	  <xsl:with-param  name="prc" select="$prc"/>
	  <xsl:with-param  name="idcla" select="$idcla"/>
	  <xsl:with-param  name="valmin" select="'8.0'"/>
	  <xsl:with-param  name="valmax" select="'9.0'"/>
	</xsl:apply-templates>   
      </xsl:variable>
      <td><xsl:value-of select="string-length($nums)"/></td>
      <xsl:variable name="numa">
	<xsl:apply-templates select="document($refgrupo)/grupo/refind">
	  <xsl:with-param  name="prc" select="$prc"/>
	  <xsl:with-param  name="idcla" select="$idcla"/>
	  <xsl:with-param  name="valmin" select="'6.6'"/>
	  <xsl:with-param  name="valmax" select="'8.0'"/>
	</xsl:apply-templates>   
      </xsl:variable>
      <td> <xsl:value-of select="string-length($numa)"/></td>

      <xsl:variable name="numi">
	<xsl:apply-templates select="document($refgrupo)/grupo/refind">
	  <xsl:with-param  name="prc" select="$prc"/>
	  <xsl:with-param  name="idcla" select="$idcla"/>
	  <xsl:with-param  name="valmin" select="'4.0'"/>
	  <xsl:with-param  name="valmax" select="'6.6'"/>
	</xsl:apply-templates>   
      </xsl:variable>
      <td><xsl:value-of select="string-length($numi)"/>
	      <xsl:if test="string-length($numi)>0">
		<br/>
		<xsl:apply-templates select="document($refgrupo)/grupo/refind" mode="Pierden">
			<xsl:with-param  name="prc" select="$prc"/>
			<xsl:with-param  name="idcla" select="$idcla"/>
			<xsl:with-param  name="valmin" select="'4.0'"/>
			<xsl:with-param  name="valmax" select="'6.6'"/>
		</xsl:apply-templates>   
	      </xsl:if>
      </td>
      
      <xsl:variable name="numd">
	<xsl:apply-templates select="document($refgrupo)/grupo/refind">
	  <xsl:with-param  name="prc" select="$prc"/>
	  <xsl:with-param  name="idcla" select="$idcla"/>
	  <xsl:with-param  name="valmin" select="'0.0'"/>
	  <xsl:with-param  name="valmax" select="'4.0'"/>
	</xsl:apply-templates>   
	</xsl:variable>
	<td><xsl:value-of select="string-length($numd)"/>
	<xsl:if test="string-length($numd)>0">
		<br/>
		<xsl:apply-templates select="document($refgrupo)/grupo/refind" mode="Pierden">
			<xsl:with-param  name="prc" select="$prc"/>
			<xsl:with-param  name="idcla" select="$idcla"/>
			<xsl:with-param  name="valmin" select="'0.0'"/>
			<xsl:with-param  name="valmax" select="'4.0'"/>
		</xsl:apply-templates>   
	</xsl:if>
	</td>
	</tr>

</xsl:template>

<!-- To process refind in file with group -->
<xsl:template match="refind">
  <xsl:param  name="prc"/>
  <xsl:param  name="idcla"/>
  <xsl:param  name="valmax"/>
  <xsl:param  name="valmin"/>

  <xsl:variable name="dir">
    <xsl:value-of select='substring-before(./@arch,"datos.ind")'/>
  </xsl:variable>
  <xsl:variable name="cprc">
	  <xsl:value-of select='concat(concat($dirplanest,"/"), concat($dir,"/",$prc))'/>
  </xsl:variable>


  <xsl:apply-templates select='document($cprc)/prcla/progcla[@idcla=$idcla]/val[@periodo=$periodo and number(@concepto)>=$valmin and number(@concepto)&lt;$valmax]'>
	<xsl:with-param  name="prc" select="$prc"/>
	<xsl:with-param  name="idcla" select="$idcla"/>
</xsl:apply-templates>


</xsl:template>

<xsl:template match="refind" mode="Pierden">
  <xsl:param  name="prc"/>
  <xsl:param  name="idcla"/>
  <xsl:param  name="valmax"/>
  <xsl:param  name="valmin"/>

  <xsl:variable name="dir">
    <xsl:value-of select='substring-before(./@arch,"datos.ind")'/>
  </xsl:variable>
  <xsl:variable name="cprc">
	  <xsl:value-of select='concat(concat($dirplanest,"/"), concat($dir,"/",$prc))'/>
  </xsl:variable>
  <xsl:variable name="nomdat">
	  <xsl:value-of select='concat(concat($dirplanest,"/"), ./@arch)'/>
  </xsl:variable>


  <xsl:variable name="num">
  <xsl:apply-templates select='document($cprc)/prcla/progcla[@idcla=$idcla]/val[@periodo=$periodo and number(@concepto)>=$valmin and number(@concepto)&lt;$valmax]'>
	<xsl:with-param  name="prc" select="$prc"/>
	<xsl:with-param  name="idcla" select="$idcla"/>
</xsl:apply-templates>
  </xsl:variable>
  <xsl:if test="string-length($num)>0">
	  <br/>
	  <xsl:value-of select="document($nomdat)/individuo/dato[@tipo='Nombres']"/>
	  <xsl:text> </xsl:text>
	  <xsl:value-of select="document($nomdat)/individuo/dato[@tipo='Apellidos']"/>
  </xsl:if>

</xsl:template>


<xsl:template match="val">
  <xsl:param  name="prc"/>
  <xsl:param  name="idcla"/>

  <xsl:text>1</xsl:text>
</xsl:template>



<xsl:template match="text()">
</xsl:template>

</xsl:stylesheet>


