<?xml version="1.0" encoding="ISO-8859-1"?>
<!-- A partir de un archivo .planest para repasa genera un script
     que establece permisos y propietarios de archivos del plan
     de estudios 
  Se cede esta fuente al dominio pblico 2003.  Sin garantas.
  http://structio.sourceforge.net/sigue structio-info@lists.sourceforge.net 
-->
<!DOCTYPE xsl:stylesheet [
]>

<xsl:stylesheet version="1.0"
        xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="text" encoding="ISO-8859-1"/>


<xsl:template match="planest">
	<xsl:text>
#!/bin/sh
# Establece permisos y propietarios de archivos en plan de estudios
# Generado automticamente con 	planest2perm.xsl 

chgrp -R profesor . 
chown root:profesor perm.sh
chmod -R o-xrw,g+r-w,u+rw ../..
chmod 4750 perm.sh
find . -type d -exec chmod gu+x {} ";"
chmod o+r *planest
</xsl:text>
	<xsl:if test="./@maneja != ''">
		<xsl:text>chown </xsl:text>
		<xsl:value-of select="./@maneja"/>
		<xsl:text> *planest 
</xsl:text>
	</xsl:if> 
	<xsl:text>
</xsl:text>
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="curso">
  <xsl:param  name="refgrupo"/>

  <xsl:apply-templates>
	<xsl:with-param  name="refgrupo" select="./@refgrupo"/>
	<xsl:with-param  name="nomgrado" select="./desc"/>
  </xsl:apply-templates> 
</xsl:template>


<xsl:template match="asignatura">
  <xsl:param  name="refgrupo"/>
  <xsl:param  name="nomgrado"/>
  <xsl:choose>
    <xsl:when test="./@refsectemas!='' and ./@refmoderador!=''">
      <xsl:variable name="nomsinext">
      	<xsl:value-of select='substring-before(./@refsectemas,".sec")'/>
      </xsl:variable>
      <xsl:variable name="nomasig">
	      <xsl:value-of select="./desc"/>
      </xsl:variable>

      <xsl:variable name="login">
      		<xsl:apply-templates select="document(./@refmoderador)/individuo/dato"/>
      </xsl:variable>
      <xsl:text>if (test ! -f "</xsl:text>
      <xsl:value-of select="$nomsinext"/>
      <xsl:text>.cla") then {
      echo '&lt;?xml version="1.0" encoding="ISO-8859-1"?&gt; 
&lt;!DOCTYPE clasificacion PUBLIC "-//Structio//DTD clasificacion 1.0" "clasif.dtd" &gt;
&lt;clasificacion&gt;
  &lt;desc&gt;Indicadores de logro de </xsl:text>
      <xsl:value-of select="$nomasig"/>
      <xsl:text> del grado </xsl:text>
      <xsl:value-of select="$nomgrado"/>
      <xsl:text> &lt;/desc&gt;
  &lt;derechos tiempo="2006" tipo="Dominio pblico"&gt;Dominio pblico. Sin garantas&lt;/derechos&gt;
&lt;/clasificacion&gt;' &gt; </xsl:text>
      <xsl:value-of select="$nomsinext"/>
      <xsl:text>.cla
} fi; 
if (test ! -f "</xsl:text>
      <xsl:value-of select="$nomsinext"/>
      <xsl:text>.sec") then {
      echo '&lt;?xml version="1.0" encoding="ISO-8859-1"?&gt; 
&lt;!DOCTYPE secuencia PUBLIC "-//Structio//DTD secuencia 1.1" "sec.dtd" &gt;
&lt;secuencia tipos="Periodo" formato="texto"&gt;
  &lt;desc&gt; </xsl:text>
      <xsl:value-of select="$nomasig"/>
      <xsl:text> del grado </xsl:text>
      <xsl:value-of select="$nomgrado"/>
      <xsl:text> &lt;/desc&gt;
  &lt;derechos tiempo="2006" tipo="Dominio pblico"&gt;Dominio pblico. Sin garantas&lt;/derechos&gt;
&lt;/secuencia&gt;' &gt; </xsl:text>
      <xsl:value-of select="$nomsinext"/>
      <xsl:text>.sec
} fi; 
</xsl:text>
      <xsl:text>chown </xsl:text>
      <xsl:value-of select="$login"/>
      <xsl:text>:profesor </xsl:text>
      <xsl:value-of select="$nomsinext"/>
      <xsl:text>.*;
</xsl:text>
      <xsl:apply-templates select="document($refgrupo)/grupo/refind">
	<xsl:with-param  name="login" select="$login"/>
	<xsl:with-param  name="prc" select="./@prc"/>
      </xsl:apply-templates> 
      <xsl:apply-templates>
	<xsl:with-param  name="refgrupo" select="$refgrupo"/>
	<xsl:with-param  name="nomgrado" select="$nomgrado"/>
      </xsl:apply-templates> 
    </xsl:when>
    <xsl:otherwise>
	<xsl:apply-templates>
		<xsl:with-param  name="refgrupo" select="$refgrupo"/>
		<xsl:with-param  name="nomgrado" select="$nomgrado"/>
      </xsl:apply-templates> 
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template match="desc">
</xsl:template>

<!-- To process dato in file of individual -->
<xsl:template match="dato">
  <xsl:if test="./@tipo='login'">
	<xsl:value-of select="."/>
  </xsl:if>
</xsl:template>


<!-- To process refind in file with group -->
<xsl:template match="refind">
  <xsl:param  name="login"/>
  <xsl:param  name="prc"/>

  <xsl:variable name="dir">
    <xsl:value-of select='substring-before(./@arch,"datos.ind")'/>
  </xsl:variable>
  <xsl:text>chown </xsl:text>
      <xsl:value-of select="$login"/>
      <xsl:text>:profesor </xsl:text>
      <xsl:value-of select="$dir"/>
      <xsl:text>/</xsl:text>
      <xsl:value-of select="$prc"/>
      <xsl:text>;
chmod o-rxw,g+r-w,u+rw </xsl:text>
      <xsl:value-of select="$dir"/>
      <xsl:text>/</xsl:text>
      <xsl:value-of select="$prc"/>
      <xsl:text>;
</xsl:text>
</xsl:template>


<xsl:template match="text()">
</xsl:template>

</xsl:stylesheet>


