<?xml version="1.0" encoding="ISO-8859-1"?>
<!-- A partir de un archivo .planest para repasa genera un script
     que cuenta valoraciones.
  Se cede esta fuente al dominio pblico 2006.  Sin garantas.
  http://structio.sourceforge.net/sigue structio-info@lists.sourceforge.net 
-->
<!DOCTYPE xsl:stylesheet [
]>

<xsl:stylesheet version="1.0"
        xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="html" encoding="ISO-8859-1"/>

<xsl:param name="periodo" required="yes"/>
<xsl:param name="prof" required="yes"/>

<xsl:template match="planest">
	<html><head><title>Valoraciones del profesor <xsl:value-of select="$prof"/> </title></head><body>
		<xsl:apply-templates/>
	</body></html>
</xsl:template>

<xsl:template match="curso">
  <xsl:param  name="refgrupo"/>

  <xsl:variable name="i">
    <xsl:apply-templates>
        <xsl:with-param  name="refgrupo" select="./@refgrupo"/>
        <xsl:with-param  name="nomgrado" select="./desc"/>
    </xsl:apply-templates>
  </xsl:variable>

  <xsl:if test="$i!=''">
	<hr/><h2><xsl:value-of select="./desc"/></h2>
        <xsl:apply-templates>
            <xsl:with-param  name="refgrupo" select="./@refgrupo"/>
            <xsl:with-param  name="nomgrado" select="./desc"/>
        </xsl:apply-templates>
  </xsl:if>
  
</xsl:template>


<xsl:template match="asignatura">
  <xsl:param  name="refgrupo"/>
  <xsl:param  name="nomgrado"/>
  <xsl:choose>
    <xsl:when test="./@refsectemas!='' and ./@refmoderador!=''">

      <xsl:variable name="loginp">
        <xsl:value-of select="document(./@refmoderador)/individuo/dato[@tipo='login']"/>
      </xsl:variable>
      <xsl:if test="$loginp=$prof">
          <hr/><h2><xsl:value-of select="./desc"/></h2>
<!--          (<xsl:value-of select="document(./@refmoderador)/individuo/dato[@tipo='Nombres']"/> <xsl:text> </xsl:text><xsl:value-of select="document(./@refmoderador)/individuo/dato[@tipo='Apellidos']"/>)  -->
        <xsl:variable name="nomsinext">
      	  <xsl:value-of select='substring-before(./@refsectemas,".sec")'/>
        </xsl:variable>
        <xsl:variable name="nomasig">
	      <xsl:value-of select="./desc"/>
        </xsl:variable>
        <table border='1'>
		<tr><th>Estudiante</th><th>Valoraciones</th><th>Fallas</th><th>Observaciones</th></tr>
		<xsl:apply-templates select="document($refgrupo)/grupo/refind">
	  		<xsl:with-param  name="prc" select="@prc"/>
		</xsl:apply-templates>   
        </table>
      </xsl:if>
    </xsl:when>
    <xsl:otherwise>
    </xsl:otherwise>
  </xsl:choose>
  <xsl:apply-templates>
	<xsl:with-param  name="refgrupo" select="$refgrupo"/>
	<xsl:with-param  name="nomgrado" select="$nomgrado"/>
  </xsl:apply-templates> 
</xsl:template>

<xsl:template match="desc">
</xsl:template>



<!-- To process refind in file with group -->
<xsl:template match="refind">
  <xsl:param  name="prc"/>

  <xsl:variable name="dir">
	<xsl:value-of select="concat('/var/saulo/planest/2007/', substring-before(./@arch,'datos.ind'))"/>
</xsl:variable>
<!--    <xsl:value-of select='substring-before(./@arch,"datos.ind")'/>
  </xsl:variable> -->
  <xsl:variable name="aind">
	  <xsl:value-of select='concat($dir,"/datos.ind")'/>
  </xsl:variable>
  <xsl:variable name="cprc">
	  <xsl:value-of select='concat($dir,"/",$prc)'/>
  </xsl:variable>

  <tr><td><xsl:value-of select="document($aind)/individuo/dato[@tipo='Nombres']"/> <xsl:text> </xsl:text><xsl:value-of select="document($aind)/individuo/dato[@tipo='Apellidos']"/> </td><td>

  <xsl:apply-templates select="document($cprc)/prcla/progcla/val[@periodo=$periodo]">
	<xsl:with-param  name="prc" select="$prc"/>
</xsl:apply-templates>
  </td>
  <td>
	  <xsl:value-of select="document($cprc)/prcla/anota[@tipo='Fallas' and @valor=$periodo]"/>
  </td>
  <td>
	  <xsl:value-of select="document($cprc)/prcla/anota[@tipo='Observaciones' and @valor=$periodo]"/>
  </td>
</tr>


</xsl:template>

<xsl:template match="val">
	<xsl:text> </xsl:text><xsl:value-of select="./@concepto"/>
</xsl:template>



<xsl:template match="text()">
</xsl:template>

</xsl:stylesheet>


